<template>
  <div class="edit_card shadow fadein">
    <h1 style="padding:0; margin:0; display: inline-block;">新建车提委{{data.order_id}}托</h1>
    <input style="font-size:2em; display: inline-block; margin-left: 10px;" placeholder="销售合同ID" v-model="data.order_id" />

    <div class="card-container">
      <!-- 上下游合同卡片 -->
      <div class="card">
        <div class="card-inner" :class="{ flipped: true }">
          <div class="card-face card-front" @click.self="toggleFlip('seller')">
            <h2 style="margin: 0;">卖方</h2>
            <p>信息继承上游合同：{{data?.purchase_order_id}}</p>
          </div>
          <div class="card-face card-back" @click.self="toggleFlip('seller')">
            <h2 style="margin: 0;">卖方</h2>
            <div class="input-group">
              <input placeholder="公司" v-model="data.seller_company" />
              <input placeholder="库区" v-model="data.store" />
            </div>
            <div class="input-group">
              <input placeholder="买方联系人" v-model="data.seller_contact" />
              <input placeholder="买方电话" v-model="data.seller_phone" />
            </div>
          </div>
        </div>
      </div>

      <!-- 车船信息 -->
      <div class="card">
        <div class="card-inner" :class="{ flipped: true }">
          <div class="card-face card-front" @click.self="toggleFlip('buyer')">
            <h2 style="margin: 0;">买方</h2>
            <div id="qcc_sdk" style="width: 100%;"></div>
            <div class="input-group">
              <input placeholder="卖方联系人" v-model="data.buyer_contact" />
              <input placeholder="卖方电话" v-model="data.buyer_phone" />
            </div>
            <div class="input-group">
              <input placeholder="开户银行" v-model="data.bank_name" />
              <input placeholder="银行账号" v-model="data.bank_id" />
            </div>
          </div>
          <div class="card-face card-back" @click.self="toggleFlip('buyer')">
            <h2 style="margin: 0;">买方详细信息</h2>
          </div>
        </div>
      </div>
    </div>

    <div style="width: 100%; background: #fdfd96;">
      <div style="display: flex; justify-content: space-between; align-items: center; margin-bottom: 10px; font-size: 24px;">
        <div style="display: flex; align-items: center; width: 40%;">
          <input style="flex-grow: 1; padding: 8px; border: 2px solid #ccc; border-radius: 4px; font-size: 24px;" placeholder="单价" v-model="data.price" />
          <p style="margin: 0; padding-right: 10px;">元/吨</p>
        </div>
        <div style="display: flex; align-items: center; width: 40%;">
          <input style="flex-grow: 1; padding: 8px; border: 2px solid #ccc; border-radius: 4px; font-size: 24px;" placeholder="数量" v-model="data.quantity" />
          <p style="margin: 0; padding-right: 10px;">吨</p>
        </div>
      </div>

      <div style="display: flex; justify-content: space-between; align-items: center;">
        <div style="display: flex; align-items: center; width: 48%;">
          <input style="width: 30%; padding: 8px; border: 1px solid #ccc; border-radius: 4px; margin-right: 10px;font-size:24px;" placeholder="提货天数" v-model="data.pickup_day" />
          <h2 style="font-size: 20px; margin: 0;">{{data.pickup_deadline}}</h2>
        </div>
      </div>
    </div>

    <button @click="data.visible = false;" class="edit_button_center" style="right:12vh;background:gray;">取消</button>
    <button @click="add_pickup_confirm" class="edit_button_center" style="right:2vh;background:green;">确定</button>
  </div>
</template>

<script setup>
import { toRefs, reactive, watch, defineProps, defineEmits, onMounted, computed } from 'vue';
//处理父子组件间的变量同步----------------------------------------------------------
const props = defineProps({
  data: {
    type: Object,
    required: true
  }
});



const emit = defineEmits(['update:data']);

const data = reactive({ 
  ...props.data,
});
watch(data, (newValue) => {
  emit('update:data', newValue);
}, { deep: true, immediate: true });
//处理父子组件间的变量同步结束------------------------------------------------------








data.pickup_deadline = computed(() => {
  return new Date(Math.min(new Date('2024-06-29').getTime() + (data.pickup_day > 1 ? data.pickup_day - 1 : 0) * 24 * 60 * 60 * 1000, 8640000000000000)).toISOString().split('T')[0]
});



function add_pickup_confirm() {
  console.log(data);
  socket.emit('add_pickup', data, (response) => {
    console.log(response);
    data.visible = false;
  });
  
}














</script>

<style scoped>
* {
  transition: 0.6s;
}

input {
  width: 40%;
  height: 40px;
}

.shadow {
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1), 
              0 6px 20px rgba(0, 0, 0, 0.1), 
              0 8px 40px rgba(0, 0, 0, 0.2);
}

.card-container {
  display: flex;
  width: 100%;
  
  background: white;
  padding: 20px;
  box-sizing: border-box;
  overflow: visible;
}

.card {
  width: 50%;
  height: 200px;
  margin: 0 10px;
  cursor: pointer;perspective: 1000px;
}

.card-inner {
  width: 100%;
  height: 100%;
  position: relative;
  transform-style: preserve-3d;
  transition: transform 0.6s;
}

.card-inner.flipped {
  transform: rotateY(180deg);
}

.card-face {
  position: absolute;
  width: 100%;
  height: 100%;
  backface-visibility: hidden;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding: 20px;
  box-sizing: border-box;
  border-radius: 10px;
  box-shadow: 0 4px 8px rgba(0,0,0,0.1);
}

.card-front {
  background-color: #ffcccc;
}

.card-back {
  background-color: #cceeff;
  transform: rotateY(180deg);
}

.input-group {
  display: flex;
  width: 100%;
  overflow: hidden;
}

.input-group input {
  box-sizing: border-box;
  width: 50%;
  border: 1px solid #ccc;
  margin: 0;
  padding: 5px;
}

.edit_card {
  position: fixed;
  left: 50%;
  top: 50%;
  transform: translate(-50%,-50%);
  width: 80vh;
  height: 50vh;
  z-index: 9999999;
  background: white;
  border-radius: 4vh;
  padding: 4vh;
}

.edit_button_center {
  position: absolute;
  bottom: 2vh;
  width: 8vh;
  height: 4vh;
  border: 0;
  border-radius: 2vh;
}
</style>